#!/bin/sh

get_section_offset()
{
    echo 0x`readelf -SW "$1" | grep " $2" | sed -e 's/\[ */\[/' | awk '{print $5}'`
}

get_symbol_offset()
{
    echo 0x`readelf -sW "$1" | grep "[0-9] $2$" | awk '{print $2}'`
}

get_symbol_num()
{
    readelf -sW "$1" | grep "LOCAL.* $2$" | sed -e 's/:.*//'
}

get_file_offset()
{
    sec=`get_section_offset $1 $2`
    sym=`get_symbol_offset $1 $3`
    echo $(($sec + $sym))
}

global_symbol()
{
    num=`get_symbol_num $1 $2`
    sec=`get_section_offset $1 ".symtab"`
    off=$(($sec + $num * 0x10 + 0xc))

    printf "sec:%x num:%x off:%x\n" $sec $num $off
    perl -e "print pack('c', 0x12);" | dd of=$1 bs=1 seek=$off count=1 conv=notrunc 2> /dev/null
}

# globalize symbols

global_symbol $1 "pxa_sd_put_command"
global_symbol $1 "pxa_sd_opendrain_command"
# global_symbol $1 "pxa_sd_get_response_value"

# ## Hook busctrl->pxa_sd_get_response_value

# func=`get_symbol_offset $1 "pxa_sd_get_response_value_mod"`
# ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 40))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook busctrl->pxa_sd_put_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 24))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook busctrl->pxa_sd_opendrain_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 28))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook calling sd_idle_card_present in sd_detect_insert()

func=$((`get_symbol_offset $1 "sd_idle_card_present_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x3884 - 0x3834))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Modify switch() table to support CMD8

func=$((`get_symbol_offset $1 "pxa_sd_put_command"`))
ptr=$((`get_file_offset $1 ".text" "pxa_sd_put_command"` + 0x4034 - 0x3f7c))

cmd=$(($func + 0x4124 - 0x3f7c))
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Hook calling sd_get_csd  in sd_detect_insert()

func=$((`get_symbol_offset $1 "sd_get_csd_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x3904 - 0x3834))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null
